
TYPO3.Flow - Bug # 32829

Status: Resolved Priority: Should have
Author: Andreas Wolf Category: Property
Created: 2011-12-24 Assigned To: Andreas Wolf
Updated: 2013-08-14 Due date:
PHP Version: 5.3
Has patch: Yes
Complexity:
Affected Flow version: FLOW3 1.0.0
Subject: Mapping to a subclass by __type property fails if subclass adds fields
Description

I have a hierarchy of classes for which an object should be created from a form. For that, I use the feature added with #30300. This
all works well until I have a new field in my subclass that is not present in the base class. Then I get the following message on
submitting my form:

#1297759968: Exception while property mapping at property path "": Property "text" was not found in target object of type
"MyCompany\MyPackage\Domain\Model\BaseClass".

This is caused by the subtype resolving done after the subproperties to map are found. The whole magic is done in 
PropertyMapper::doMapping(): First the type converter is created, then all subproperties (of the base class, as annotated in my
controller action) are fetched in getSourceChildPropertiesToBeConverted(). After this, the object should be created, but the mapping
fails first because the property does not exist.

The solution is to do the final type resolution directly after creating the type converter, before the call to 
getSourceChildPropertiesToBeConverted().

Related issues:
related to TYPO3.Flow - Feature # 30300: Support mapping to subclass by argument Resolved 2011-09-26

Associated revisions
Revision 81997950 - 2013-02-14 12:59 - Andreas Wolf

[BUGFIX] Mapping to subtype with [__type] fails

The type of a target object can be manipulated by setting __type in the
form (or during action initialization when saving the form). This
however fails if the target subclass contains fields that the original
class does not have, because the property mapping is done before the
final class is extracted from the __type request variable.

To get this working, the process of getting the final class name is
moved before the property mapping.

If you wrote your own type converters, you might need to implement the
new getTargetTypeForSource() method if you do not extend the provided
AbstractTypeConverter of Flow.

Change-Id: Ia42e374202845dfe5e95c72512e9fefb4f00e789
Fixes: #32829
Releases: master, 2.0, 1.1

Revision 45ea2277 - 2013-02-15 12:55 - Christian Müller

[BUGFIX] Flow should work with PHP versions lower than 5.3.9

The change Ia42e374202845dfe5e95c72512e9fefb4f00e789 introduced
usage of is_a() with 3 arguments which is only implemented from
PHP 5.3.9. This change replaces the call with a manual check for
inheritance.

Change-Id: I05c42b785e3f49e974cd5b381940e96130e5b0dc
Related: #32829
Releases: master

Revision e23dc49c - 2013-03-20 16:33 - Andreas Wolf

[BUGFIX] Mapping to subtype with [__type] fails

The type of a target object can be manipulated by setting __type in the
form (or during action initialization when saving the form). This
however fails if the target subclass contains fields that the original
class does not have, because the property mapping is done before the
final class is extracted from the __type request variable.

To get this working, the process of getting the final class name is
moved before the property mapping.

If you wrote your own type converters, you might need to implement the
new getTargetTypeForSource() method if you do not extend the provided
AbstractTypeConverter of Flow.

Change-Id: Ia42e374202845dfe5e95c72512e9fefb4f00e789
Fixes: #32829
Releases: master, 2.0, 1.1

Revision f64f3cc9 - 2013-04-05 18:40 - Christian Müller

[BUGFIX] Flow should work with PHP versions lower than 5.3.9

The change Ia42e374202845dfe5e95c72512e9fefb4f00e789 introduced
usage of is_a() with 3 arguments which is only implemented from
PHP 5.3.9. This change replaces the call with a manual check for
inheritance.

Change-Id: I05c42b785e3f49e974cd5b381940e96130e5b0dc
Related: #32829
Releases: master, 2.0, 1.1
Revision eee02f3b - 2013-04-05 19:36 - Andreas Wolf

[BUGFIX] Mapping to subtype with [__type] fails

The type of a target object can be manipulated by setting __type in the
form (or during action initialization when saving the form). This
however fails if the target subclass contains fields that the original
class does not have, because the property mapping is done before the
final class is extracted from the __type request variable.

To get this working, the process of getting the final class name is
moved before the property mapping.

If you wrote your own type converters, you might need to implement the
new getTargetTypeForSource() method if you do not extend the provided
AbstractTypeConverter of Flow.

Change-Id: Ia42e374202845dfe5e95c72512e9fefb4f00e789
Fixes: #32829
Releases: master, 2.0, 1.1

Revision 006c7eb9 - 2013-04-05 19:37 - Christian Müller

[BUGFIX] Flow should work with PHP versions lower than 5.3.9

The change Ia42e374202845dfe5e95c72512e9fefb4f00e789 introduced
usage of is_a() with 3 arguments which is only implemented from
PHP 5.3.9. This change replaces the call with a manual check for
inheritance.

Change-Id: I05c42b785e3f49e974cd5b381940e96130e5b0dc
Related: #32829
Releases: master, 2.0, 1.1

History
#1 - 2011-12-24 13:25 - Gerrit Code Review
- Status changed from New to Under Review

Patch set 1 for branch master has been pushed to the review server.
It is available at http://review.typo3.org/7507

#2 - 2011-12-24 14:01 - Gerrit Code Review

Patch set 2 for branch master has been pushed to the review server.
It is available at http://review.typo3.org/7507

#3 - 2011-12-24 21:53 - Gerrit Code Review
Patch set 3 for branch master has been pushed to the review server.
It is available at http://review.typo3.org/7507

#4 - 2012-01-11 10:36 - Karsten Dambekalns
- Category set to Property
- Assigned To set to Andreas Wolf
- Target version set to 1.1

#5 - 2012-01-11 12:13 - Gerrit Code Review

Patch set 4 for branch master has been pushed to the review server.
It is available at http://review.typo3.org/7507

#6 - 2012-03-20 18:02 - Gerrit Code Review

Patch set 5 for branch master has been pushed to the review server.
It is available at http://review.typo3.org/7507

#7 - 2012-05-21 23:23 - Gerrit Code Review

Patch set 6 for branch master has been pushed to the review server.
It is available at http://review.typo3.org/7507

#8 - 2012-05-22 11:55 - Gerrit Code Review

Patch set 7 for branch master has been pushed to the review server.
It is available at http://review.typo3.org/7507

#9 - 2012-05-25 09:39 - Karsten Dambekalns
- Target version changed from 1.1 to 1.1 RC1

#10 - 2012-06-19 11:15 - Karsten Dambekalns
- Target version changed from 1.1 RC1 to 1.1
- Affected Flow version changed from Git master to Git 1.1

#11 - 2012-06-19 11:15 - Karsten Dambekalns
- Affected Flow version changed from Git 1.1 to FLOW3 1.0.0

#12 - 2012-06-25 17:59 - Gerrit Code Review

Patch set 8 for branch master has been pushed to the review server.
It is available at http://review.typo3.org/7507

#13 - 2012-06-25 18:45 - Gerrit Code Review

Patch set 9 for branch master has been pushed to the review server.
It is available at http://review.typo3.org/7507
#14 - 2012-08-14 10:12 - Gerrit Code Review

Patch set 10 for branch master has been pushed to the review server.
It is available at http://review.typo3.org/7507

#15 - 2012-08-17 11:19 - Karsten Dambekalns
- Target version changed from 1.1 to 1.1.1

#16 - 2012-08-22 17:58 - Gerrit Code Review

Patch set 11 for branch master has been pushed to the review server.
It is available at http://review.typo3.org/7507

#17 - 2012-08-22 17:59 - Gerrit Code Review

Patch set 12 for branch master has been pushed to the review server.
It is available at http://review.typo3.org/7507

#18 - 2012-08-23 11:54 - Gerrit Code Review

Patch set 13 for branch master has been pushed to the review server.
It is available at http://review.typo3.org/7507

#19 - 2012-08-23 12:15 - Gerrit Code Review

Patch set 14 for branch master has been pushed to the review server.
It is available at http://review.typo3.org/7507

#20 - 2012-09-13 11:01 - Gerrit Code Review

Patch set 15 for branch master has been pushed to the review server.
It is available at http://review.typo3.org/7507

#21 - 2012-12-14 15:09 - Karsten Dambekalns
- Target version changed from 1.1.1 to 2052

#22 - 2013-01-15 15:57 - Marco Falkenberg

Are there any news or efforts about solving this bug?

#23 - 2013-02-14 13:01 - Gerrit Code Review

Patch set 16 for branch master has been pushed to the review server.
It is available at https://review.typo3.org/7507
#24 - 2013-02-14 18:37 - Andreas Wolf
- Status changed from Under Review to Resolved
- % Done changed from 0 to 100

Applied in changeset commit:81997950b7819d9bc7938ee79dcc9aaedab6dcdc.

#25 - 2013-03-20 16:35 - Gerrit Code Review
- Status changed from Resolved to Under Review

Patch set 1 for branch 2.0 has been pushed to the review server.
It is available at https://review.typo3.org/19095

#26 - 2013-03-20 16:49 - Gerrit Code Review

Patch set 1 for branch FLOW3-1.1 has been pushed to the review server.
It is available at https://review.typo3.org/19096

#27 - 2013-04-05 19:24 - Gerrit Code Review

Patch set 2 for branch FLOW3-1.1 has been pushed to the review server.
It is available at https://review.typo3.org/19096

#28 - 2013-04-05 19:35 - Gerrit Code Review

Patch set 3 for branch FLOW3-1.1 has been pushed to the review server.
It is available at https://review.typo3.org/19096

#29 - 2013-04-05 19:37 - Gerrit Code Review

Patch set 4 for branch FLOW3-1.1 has been pushed to the review server.
It is available at https://review.typo3.org/19096

#30 - 2013-04-05 20:37 - Andreas Wolf
- Status changed from Under Review to Resolved

Applied in changeset commit:eee02f3ba30976da289da0d19fc6a905d703e059.

#31 - 2013-04-10 15:26 - Andreas Wolf

This still seems to be an issue when changing already persisted objects when the type is not submitted with the form (which may not be desired for
several reasons). The reason is that the ObjectConverter does not check if the object has already been persisted (= if $source[__identity] is present)
when checking for the target type (in getTargetTypeForSource)
#32 - 2013-08-14 15:39 - Karsten Dambekalns
- Target version changed from 2052 to 1.1.1
